'''
Clase Chat. Representa una conversación entre el o los usuarios y el bot
'''
class Chat:
    Chats = {}
    
    '''
    Constructor de la clase
    @param self: el propio objeto Chat
    @param idChat: identificador del chat dado por Telegram
    '''
    def __init__(self, idChat):
        self.idChat = idChat
        self.idList = None
        self.nameTask = None
        self.inlineMsg = None
        self.language = 'ES'
        self.members = []

	#--------GETTERS------------
    def getId(self):
        return self.idChat
        
    def getIdList(self):
        return self.idList
    
    def getNameTask(self):
        return self.nameTask
    
    def getInlineMsg(self):
        return self.inlineMsg

    def getLanguage(self):
        return self.language
    
    def getMembers(self):
        return self.members

    #--------SETTERS------------
    def setId(self, idChat):
        self.idChat = idChat
        
    def setIdList(self, idList):
        self.idList = idList
    
    def setNameTask(self, nameTask):
        self.nameTask = nameTask
    
    def setInlineMsg(self, inlineMsg):
        self.inlineMsg = inlineMsg
        
    def setLanguage(self, language):
        self.language = language
        
    def setMembers(self, members):
        self.members = members
        
    #----------MÉTODOS-------------#
    '''
    Comprueba si un usuario es miembro o no del chat (grupo) indicado
    @param self: el propio objeto Chat
    @param _id: identificador del usuario que se quiere comprobar
    @return boolean: True si es miembro, False si no
    '''
    def isMember(self, _id):
        for m in self.members:
            #Se castea a str porque _id y m pueden ser chat_id o username 
            if str(m) == str(_id):
                return True
        return False
      
    '''
    Añade el usuario indicado al chat (grupo)
    @param self: el propio objeto Chat
    @param _id: identificador del usuario que se quiere insertar
    '''  
    def joinGroup(self, _id):
        self.members.append(_id)
    
    '''
    Elimina el usuario indicado del chat (grupo)
    @param self: el propio objeto Chat
    @param _id: identificador del usuario que se quiere eliminar
    '''
    def leftGroup(self, _id):
        self.members.remove(_id)