from enum import Enum

'''
Clase States. Representa un estado de los que puede tener una checklist. 
Hereda de clase Enum (Enumeracion)
'''
class States(Enum):
    CREATE = 1
    ADDTASK = 2
    EDIT = 3
    DONE = 4

'''
Clase Checklist. Representa una lista de comprobacion.
'''
class Checklist:
    idList = 1
    Checklists = {}
   
    '''
    Constructor de la clase
    @param self: el propio objeto Checklist
    @param name: nombre de la checklist
    @param owner: identificador del usuario creador
    @param idList: identificador de checklist
    '''
    def __init__(self, name, owner, idList):
        if idList == None:
            self.idList = Checklist.idList
            Checklist.idList += 1
        else:
            self.idList = idList
            
        self.name = name
        self.owner = owner
        self.messages = []
        self.state = States(1).name
 
	#--------GETTERS------------        
    def getId(self):
	    return self.idList
	    
    def getName(self):
        return self.name
	    
    def getOwner(self):
        return self.owner
	
    def getMessages(self):
        return self.messages
    
    def getState(self):
        return self.state
    
    #--------SETTERS------------ 
    def setId(self, idList):
        self.idList = idList
	   
    def setName(self, name):
        self.name = name
	
    def setOwner(self, owner):
        self.owner = owner
	
    def setMessages(self, messages):
        self.messages = messages
    
    def setState(self, state):
        if isinstance(state, int):
            self.state = States(state).name
        elif isinstance(state, str):
            self.state = States[state].name
      
    #----------MÉTODOS-------------#  
    '''
    Añade un mensaje a los mensajes donde se muestra la checklist
    @param self: el propio objeto Checklist
    @param msg: mensaje a añadir
    '''
    def appendMsg(self, msg):
        if self.findOldMsg(msg) == None:
            self.messages.append(msg)
     
    '''
    Elimina un mensaje de los mensajes donde se muestra la checklist
    @param self: el propio objeto Checklist
    @param msg: mensaje a borrar
    '''   
    def removeMsg(self, msg):
        if msg in self.messages:
            self.messages.remove(msg)
     
    '''
    Busca un mensaje con mismo identificador de chat que el mensaje proporcionado
    @param self: el propio objeto Checklist
    @param msg: mensaje del cual se quiere localizar otro con mismo id de chat
    '''          
    def findOldMsg(self, msg):
        for m in self.messages:
            if isinstance(m, tuple):
                if msg[0] == m[0]:
                    return m
        return None
    
    '''
    Reemplaza un mensaje por otro posterior con mismo id de chat
    @param self: el propio objeto Checklist
    @param msg: nueva mensaje que reemplaza al antiguo
    '''               
    def replaceMsg(self, msg):
        oldMsg = self.findOldMsg(msg)
        if oldMsg != None:
            i = self.messages.index(oldMsg)
            self.messages[i] = msg
        else:
            self.appendMsg(msg)